
#include 'AppEvent.ch'
#include 'FileIO.ch'
#include 'Error.ch'
#include 'Gra.ch'
#include 'Thread.ch'
#include 'Xbp.ch'
#include 'XbpDev.ch'
#include 'Set.ch'

#define  CR                      Chr(13)
#define  LF                      Chr(10)
#define  CRLF                    CR+LF
#define  FF                      Chr(12)
#define  BS                      Chr(08)
                  //
                  //    For using with XbpPrinter():paperSize()
#define  PAPER_WIDTH             1        // in 1/10 mm (= nXsize)
#define  PAPER_HEIGHT            2        // in 1/10 mm (= nYsize)
#define  PAPER_LEFT_MARGIN       3        // in 1/10 mm (= nLeftMargin)
#define  PAPER_BOTTOM_MARGIN     4        // in 1/10 mm (= nBottomMargin)
#define  PAPER_RIGHT_MARGIN      5        // in 1/10 mm (= nRightMargin)
#define  PAPER_TOP_MARGIN        6        // in 1/10 mm (= nTopMargin)
#define  PAPER_WIDTH_IN_PIXEL    7
#define  PAPER_HEIGHT_IN_PIXEL   8
                  //
                  //    Defines and working tokens
#define  nBUFFERMAT  98304                // Limite de bytes enviados para impressoras matriciais
#define  nLINESIZE  524288
#define  nLINEHEIGHT     3                // Line Height
#define  fNORMAL       'n'                // Token for selection of the font normal
#define  fCONDEN       'c'                // Token for selection of the font condensed
#define  fDOBRA        'd'                // Token for selectionof the font double
#define  fCANCELA      'k'                // Cancels previous selected font
#define  lENFATI       'e'                // Starts emphasized (bold) printing mode
#define  lCENFATI      'x'                // Ends the emphasized (bold) printing mode
#define  tINITPR       'i'                // Printer initialization
#define  tENDPR        'f'                // Printer reseting
#define  tSTARTPAGE    'p'                // :startPage()
#define  tNEWPAGE      'g'                // :newPage()
#define  tENDPAGE      'o'                // :endPage()
#define  tSTARTDOC     'w'                // :startDoc()
#define  tENDDOC       'z'                // :endDoc()
#define  tROWCOL       'r'                // Row Col positioning
#define  tSTRING       's'                // String
#define  tHLINE        'h'                // Horizontal Line
#define  tVLINE        'v'                // Vertical Line
#define  tCODEBLOCK    '!'                // Code Blocks
#define  tPICTURE      '*'                // Picture for background
                  //
                  //    Array that describes the picture for printing in BG
#define  I_FILE          01
#define  I_POS           02
#define  PIC_LEN            02
                  //
                  //    Tokens.
                  //           Read 'Ec' as Chr(27)
//            'EcEc'       -> start of the report. Its format is:
//                            'EcEc'                                                +;
//                            [<'V'> | <'H'>] -> paper orientation: Portrait ('V')
//                                                                  Landscape ('H') +;
//                            Chr(<nLinPage>) ->  Lines per page                    +;
//                            Chr(nLeftMargin)                                      +;
//                            Chr(nLinesPerInch)                                    +;
//                            Printing Level: '1' -> XBPPRN_RESOLUTION_DRAFT
//                                            '2' -> XBPPRN_RESOLUTION_LOW
//                                            '3' -> XBPPRN_RESOLUTION_MEDIUM
//                                            '4' -> XBPPRN_RESOLUTION_HIGH
//                            Inserted by Start_()
//            'EcChr(255)' -> end of the report
//                            Inserted by saida_()
//            'EcP'        -> start page
//                            See XbpPrinter() documentation.
//                            Inserted by the program if needed changing printing
//                                     properties.
//            'EcF'        -> end page.
//                            Normally used with 'EcP'
//                            See XbpPrinter() documentation.
//                            Inserted by the program if needed changing printing
//                                     properties.
//            'EcG'        -> new page
//                            Inserted by saida_(). Is the same is 'EcF' + changing
//                                     printing properties + 'EcG'
//            'EcC'        -> condense the current font
//                            Inserted by the program
//            'EcD'        -> double size the current font
//                            Inserted by the program.
//                            . In not graphical printers it remains only in one
//                              line. Each "doubled" string must starts with
//                              dobra_ and finishes with cdobra_
//                            . In graphical printers the string starts with
//                              dobra_ and ends with cdobra_, independing on
//                              the amount of lines
//            'EcE'        -> "Emphasized" the current font (bold)
//                            Inserted by the program
//            'EcX'        -> cancel "Emphasized" (bold)
//                            Inserted by the program
//            'EcK'        -> return to the previous font
//                            Inserted by the program
//            'EcN'        -> font normal (10 cpi). It is the starting font
//                            Inserted by the program
//            'EcH'        -> horizontal(s) line(s) of the width of one column.
//                            They are not emphasized nor condensed nor doubled
//                            Its format is:
//                            'EcH'                                             +;
//                            I2Bin(nCols) -> how many columns are to be drawn
//                            Inserted by PrtSay_()
//            'Ec.'        -> coordinate for printing the string (string starts after
//                            the "token" and ends in the next token ('Ec')).
//                            Its format is:
//                            'Ec.'                       +;
//                            U2Bin(Int(nRow * 100))      +;
//                            U2Bin(Int(nCol * 100)).
//                            Inserted by PrtSay_()
//                            This means that nRow and nCol can have until 2 decimals
//                            for fine alignament.
//            'Ec|'        -> identify vertical line of the height of the row.
//                            RESERVED.
//                            The are not emphasized nor condensed nor doubled
//                            Inserted by the program. It is the content of the
//                            PUBLIC VAR linver_
//            'Ec!'        -> code block for being evaluated during the printing
//                            process.
//                            Its format is:
//                            'Ec!'                  +;
//                            I2Bin(Len(cCodeBlock)) +;
//                            cCodeBlock -> code block informed as string.
//                                          Example:
//                                    "{|oPrt| GraStringAt(oPrt, {122, 69}, 'Example'})}"
//                            It is informed as string and is compiled and executed
//                            in PrintFor.prg (Xbase++).
//                            Specification of strings that contain starting portion
//                            (or all) of tokens or Chr(...) must be specified delimited.
//                            Example: "Chr(27) + string preceeded by ESC"
//                            Receives as parameter a object of the class PrintFor_
//                            Inserted by the program
//            'Ec*'        -> picture for been printed as background of the pages
//                            starting of the page where this "token" is found and
//                            the next pages until the end of the report or another
//                            'Ec*' is found without a valid picture or an empty array
//                            Its format is:
//                            'Ec*'                  +;
//                             <cLen>                +;
//                            "{<cPos>,;
//                              [<cFileName>],;
//                              [<nResId>],;
//                              [<cDll>],;
//                              [<xUserDef>],;
//                              [<cUserType>],;
//                              [<nXPos>],;
//                              [<nYPos>]}"
//
//                              <cLen>        -> I2Bin(Len(cArray))
//                              <cPos>        -> identify the position of the image in
//                                               the page:
//                                               The first byte means:
//                                                'L' -> the image will be printed in the
//                                                       left side of the X axe
//                                                'C' -> the image will be printed
//                                                       centered int the X axe
//                                                'R' -> the image will be printed at the
//                                                       right of the X axe
//                                                'X' -> the parameter <nXPos> will have
//                                                       the axe X position of the picture
//                                                       and the parameter <nYPos>
//                                                       have the vertical one
//                                               The second byte means:
//                                                'B' -> the image will be printed in
//                                                       the bottom of the Y axe
//                                                'C' -> the image will be printed
//                                                       centered int the Y axe
//                                                'T' -> the image will be printed in the
//                                                       top of the X axe
//                                                'Y' -> the parameter <nYPos> will have
//                                                       the axe Y position of the picture
//                                                       and the parameter <nXPos>
//                                                       have the horizontal one
//                            [<cFileName>] -> complete path of the file that contains
//                                             the picture. If informed the [<nResId>]
//                                             and [<cDll>] are ignored.
//                            [<nResId>]    -> is a resource ID in the Resource File that
//                                             was linked in a DLL.
//                                             If informed the <cDll> must be informed
//                            [<cDll>]      -> the complete path where is the Dll that
//                                             contains the <nResId> or <xUserDef>
//                                             Must be informed if <nResId> or <xUserDef>
//                                             was informed.
//                            [<xUserDef>]  -> Identification of the resource defined
//                                             in the section USERDEF of the Resource File
//                                             Obrigatory if <cFileName> and <nRedId>
//                                             was not informed.
//                            [<cUserType>]  -> Type of <xUserDef>
//                                              Obrigatory if <xUserDef> was informed
//                            [<nXPos>]      -> I2Bin() of the desired position of the
//                                              picture (see <cPos>) in the axe X
//                            [<nYPos>]      -> I2Bin() of the desired position of the
//                                              picture (see <cPos>) in the axe Y
//
//            Chr(127)     -> RESERVED. If used inform it as Chr(127)
//            CRLF         -> is transformed in '' when inserted in strings
//            FF           -> is transformed in '' when inserted in strings
//            CR           -> is transformed in '' when inserted in strings
//            LF           -> is transformed in '' when inserted in strings


/////////////
//
//    Printform_()New(<cPrtFile>,    <cFormDest>,   <cPrinter>,       <cToFile>,;
//                    <cUser>,       <cFontFamily>, <nFontNormWidth>, <nFontHeight>,;
//                    <nTotColumns>, <cMsgId>,      [<cCallStack>])
//
//    Cria um objeto da classe Pintform_() para imprimir ou gravar em disco um determinado
//         relatrio, onde:
//         <cPrtFile>       -> Full path of the file that contains the report generated
//         <cFormDest>      -> Type of the file to be formated:
//                             'hdm'              // Matricial Printer format ESC P for to be written to the disk
//                             'hdp'              // Graphic   Printer format PCL for to be written to the disk
//                             'exp'              // File wrote in plain text format
//                             'gra'              // Graphic mode directed printing
//                             'mat'              // Format ESC P directed printing
//                             'pcl'              // Format PCL   directed printing
//         <cPrinter>          Output Printer device
//         <cToFile>           if not empty is the full path of the file for to be written to disk
//         <cUser>             User name
//         <cFontFamily>       Selected font family
//         <nFontNormWidth> -> Width
//         <nFontHeight>       Height
//         <nTotColumns>       Total of columns of the report
//         <cMsgId>            Application code for to be shown show in the title of the messages
//         [<cCallStack>]      Call Stack for to be shown in case of error
//
//    A classe Printform_() executa em uma thread separada, o que permite que se imprima o relatrio
//      enquanto se pode continuar processando o sistema.
//

 ////////////
 //
CLASS PrintForm_ FROM Thread
 //
 /////
PROTECTED:
   VAR      nCharSet
   VAR      cPrtFile             // Because of the threads
   VAR      cFormDest
   VAR      cPrinter
   VAR      cToFile
   VAR      cFontFamily
   VAR      nFontHeight
   VAR      nColCondens
   VAR      nColDouble

   VAR      cMsgId
   VAR      cUser
   VAR      cCallStack

   VAR      cBuffer
   VAR      nBufferLen
   VAR      nPos
   VAR      cFontStack
   VAR      hReport
   VAR      lEnfati

   VAR      oFontNormal
   VAR      oFontNormalEnf
   VAR      oFontConden
   VAR      oFontCondenEnf
   VAR      oFontDobra
   VAR      oFontDobraEnf
   VAR      oPicture
   VAR      aPicturePos
   VAR      aBG

   METHOD   ShowMsg(oOwner, cMens, cTitle, nButtons, nStyle)
   METHOD   checkEvent()
   METHOD   clearString()
   METHOD   conv2Print()         // Converte caracteres acentuados para Chr+BSPACE+accent
   METHOD   createPrinter()
   METHOD   destroy()
   METHOD   printBG()
   METHOD   graphicMode()
   METHOD   init(cPrtFile,  cPrinter,    cToFile,          cUser,;
                            cFontFamily, nFontNormalWidth,;
                            nFontHeight, nTotColumns,      cMsgId)
   METHOD   loadFont(nWidth, lBold, lUndersCore, lItalic)
   METHOD   loadPicture(aPicture)
   METHOD   printToFile()
   METHOD   readBlock(nBlockLen)
   METHOD   readBuffer()
   METHOD   readString(cStringRead)
   METHOD   readToken(cType, mp1, mp2, mp3, mp4, mp5)       // Passados por referncia
   METHOD   sharedPrinter()
   METHOD   selectFont()
   METHOD   setPrintFont(cNewFont)

EXPORTED:
   VAR      nTotColumns   READONLY
   VAR      nLineHeight   READONLY
   VAR      nLinHorSpace  READONLY
   VAR      nStringYPos   READONLY
   VAR      nColWidth     READONLY
   VAR      nVLineX       READONLY
   VAR      nLeftMargin   READONLY
   VAR      nRow0         READONLY
   VAR      nCol0         READONLY
   VAR      nTopPos       READONLY
   VAR      nBottomPos    READONLY
   VAR      nRightPos     READONLY
   VAR      aPos          READONLY
   VAR      oPrint        READONLY
   VAR      oPrintPS      READONLY

   METHOD   print()
   METHOD   printError(e)

   INLINE METHOD execute()
          ::print()
          ::destroy()
   RETURN Self
ENDCLASS

METHOD Printform_:checkEvent()
       LOCAL  nEvent, mp1, mp2, oXbp

       nEvent          := NextAppEvent(@mp1, @mp2, @oXbp)
       do while nEvent <> xbe_None
         Appevent()
         oXbp:handleEvent(nEvent, mp1, mp2, oXbp)
         nEvent := NextAppEvent(@mp1, @mp2, @oXbp)
      enddo
RETURN Self

METHOD Printform_:clearString(cString)
       if (CRLF $ cString)
          cString := StrTran(cString, CRLF, '')
       endif
       if (LF $ cString)
          cString := StrTran(cString, LF,   '')
       endif
       if (FF $ cString)
          cString := StrTran(cString, FF,   '')
       endif
       if (CR $ cString)
          cString := StrTran(cString, CR,   '')
       endif
       if (BS $ cString)
          cString := StrTran(cString, BS,   '')
       endif
RETURN cString

METHOD PrintForm_:conv2Print()
STATIC  cAcentos, cTransform
LOCAL   nInd, cChar, cPrint, nAT

if cAcentos == NIL
                  //
                  //    Os acentos comeam com caracteres ANSI e depois OEM.
   cAcentos   := ('' +;  // ANSI
                  '䠂酊냈ꄉؙ')    // OEM
                  //
                  //    Cada 3 caracteres formam a sequncia para impresso
   cTransform := ([c,C,a~A~O~o~a'e'i'o'u'A'E'I'O'U'a`e`i`o`u`A`E`I`O`U`a^] +;
                  [e^i^o^u^A^E^I^O^U^a"e"i"o"u"A"E"I"O"U"] +;     // ANSI
                  [c,C,a~A~O~o~a'e'i'o'u'A'E'I'O'U'a`e`i`] +;     // OEM
                  [o`u`A`E`I`O`U`a^e^i^o^u^A^E^I^O^U^a"e"] +;
                  [io"u"A"E"I"O"U"])
endif

for nInd  := 1 to ::nBufferLen
    if ::cBuffer[nInd] <= Chr(126)        // Caracteres comuns
       loop
    endif

    cChar := ::cBuffer[nInd]
    nAt   := At(cChar, cAcentos)
    if nAt == 0
       loop
    endif

    cPrint := SubStr(cTransform, (((nAt - 1) * 3) + 1), 3)
    nAt    := nInd
    do while .t.
       ::cBuffer := StrTran(::cBuffer, cChar, cPrint)
       nAt       := At(cChar, ::cBuffer, nAt)      // Ficou algum caractere sem transformar?
       if  nAt   == 0
          exit
       endif
       nAt += 3
    enddo
    ::nBufferLen := Len(::cBuffer)
    nInd         += 2            // Para saltar os caracteres traduzidos
next
RETURN NIL

METHOD Printform_:createPrinter()
    LOCAL  lOk

    do while .t.
       GraSetPointer_(SetAppWindow(), NIL, XBPSTATIC_SYSICON_WAIT, XBPWINDOW_POINTERTYPE_SYSPOINTER)
       ::oPrint := XbpPrinter():new():create(::cPrinter)
       GraSetPointer_(SetAppWindow(), NIL, XBPSTATIC_SYSICON_DEFAULT, XBPWINDOW_POINTERTYPE_SYSPOINTER)
       if ::oPrint:status() <> XBP_STAT_CREATE
          ::oPrint          := NIL
          if ::showMsg(NIL, (::cUser + ': NO FOI POSSVEL criar o objeto da IMPRESSORA:' + CR + CR +;
                             ::cPrinter),;
                            (::cMsgId  + 'ERRO PARA IMPRESSO'),;
                             XBPMB_RETRYCANCEL,;
                             (XBPMB_QUESTION + XBPMB_SYSMODAL)) == XBPMB_RET_RETRY
             loop
          endif
          lOk := .f.
       else
          lOk := PrinterStatus_(::oPrint, ::cUser, ::cMsgId, ::cCallStack)
       endif
       exit
    enddo
RETURN lOk

METHOD PrintForm_:destroy()
       if  ::oFontNormal    <> NIL;  ::oFontNormal:destroy();                  endif
       if  ::oFontNormalEnf <> NIL;  ::oFontNormalEnf:destroy();               endif
       if  ::oFontDobra     <> NIL;  ::oFontDobra:destroy();                   endif
       if  ::oFontDobraEnf  <> NIL;  ::oFontDobraEnf:destroy();                endif
       if  ::oFontConden    <> NIL;  ::oFontConden:destroy();                  endif
       if  ::oFontCondenEnf <> NIL;  ::oFontCondenEnf:destroy();               endif
       if  ::oPicture       <> NIL;  ::oPicture:destroy();                     endif

       if ::hReport > 0
          FClose(::hReport)
          FErase(::cPrtFile)
       endif

       if ::oPrintPS <> NIL
          ::oPrintPS:destroy()
          ::oPrintPS := NIL
       endif
       if ::oPrint <> NIL
          if ::oPrint:status() == XBP_STAT_CREATE
             ::oPrint:destroy()
          endif
          ::oPrint := NIL
       endif
       ::checkEvent()
       ::Thread:setInterval(NIL)
       Set(_SET_CHARSET, ::nCharset)
RETURN NIL

METHOD PrintForm_:graphicMode()
       LOCAL  cToken, p1,    p2,       p3,               p4,             p5,;
              nLen,          lOk,      aStartPoint[02],  aEndPoint[02],;
              nY,            cOldFile, aPaper,;
              aPageSize[02], bError
                  //
                  //    Cria impressora e Presentation Space
       lOk := ::readBuffer()
       do while lOk
          if !::createPrinter()
             exit
          endif

          if ''              <> ::cToFile
             cOldFile        := ::oPrint:setPrintFile(::cToFile)
             if     cOldFile == NIL
                    ::showMsg(NIL, (::cUser + ': No  possvel GRAVAR relatrio(s) na impressora:' + CR + CR +;
                                    ::cPrinter) +;
                                   (::cMsgId + 'ERRO NA IMPRESSO'),;
                                   XBPMB_CANCEL,;
                                   (XBPMB_CRITICAL + XBPMB_SYSMODAL))
                    lOk := .f.
                    exit
             elseif ''       == cOldFile
                    ::showMsg(NIL, (::cUser + ': a impressora: ' + ::cPrinter + CR + CR +;
                                    'Est desabilitada para GRAVAR relatrios.'),;
                                   (::cMsgId + 'ERRO NA IMPRESSO'),;
                                   XBPMB_CANCEL,;
                                   (XBPMB_CRITICAL + XBPMB_SYSMODAL))
                    lOk := .f.
                    exit
             endif
          endif

          ::readToken(@cToken, @p1, @p2, @p3, @p4, @p5)
          if 'H' == p1
             ::oPrint:setOrientation(XBPPRN_ORIENT_LANDSCAPE)
          else
             ::oPrint:setOrientation(XBPPRN_ORIENT_PORTRAIT)
          endif
          if     p5 == '1'
                 ::oPrint:setResolution(XBPPRN_RESOLUTION_DRAFT)
          elseif p5 == '2'
                 ::oPrint:setResolution(XBPPRN_RESOLUTION_LOW)
          elseif p5 == '4'
                 ::oPrint:setResolution(XBPPRN_RESOLUTION_HIGH)
          else
                 ::oPrint:setResolution(XBPPRN_RESOLUTION_MEDIUM)
          endif
                  //
                  //    Creating the fonts
          ::oFontNormal    := ::loadFont(::nColWidth,   .f., .f., .f.)
          ::oFontNormalEnf := ::loadFont(::nColWidth,   .t., .f., .f.)
          ::oFontConden    := ::loadFont(::nColCondens, .f., .f., .f.)
          ::oFontCondenEnf := ::loadFont(::nColCondens, .t., .f., .f.)
          ::oFontDobra     := ::loadFont(::nColDouble,  .f., .f., .f.)
          ::oFontDobraEnf  := ::loadFont(::nColDouble,  .t., .f., .f.)
                  //
                  //    Printing parameters
          ::nLineHeight  := Int((254 / p4))        // Lines per Inch (2,54 mm * 100)
          ::nLinHorSpace :=  Round(((::nLineHeight - (nLINEHEIGHT * 2)) / 2), 0)
          ::aPos[01]     := 0                     // The first one string can be empty
          ::aPos[02]     := 0
          ::nColWidth    := ::oFontNormal:width
          ::nStringYPos  := Round(((::nLineHeight        - ::oFontNormal:height) / 2), 0)
          ::nLeftMargin  := p3
                  //
                  //    Rendering image parameters that not depends on font
          ::nTopPos    := (p2        * ::nLineHeight)
          ::nRow0      := (::nTopPos - ::nLineHeight)
          ::nBottomPos := ::nLineHeight
                       //
                       //    PresSpace for printing
          aPaper               := ::oPrint:paperSize()
          aPageSize[01]        := aPaper[PAPER_RIGHT_MARGIN]  // Complete PresSpace area
          aPageSize[02]        := aPaper[PAPER_TOP_MARGIN]
          aPaper               := Array(GRA_AL_COUNT)
          aPaper[GRA_AL_TYPE]  := GRA_LINETYPE_SOLID
          aPaper[GRA_AL_WIDTH] := nLINEHEIGHT
          ::oPrintPS := XbpPresSpace():new():create(::oPrint, aPageSize, GRA_PU_LOMETRIC)
          ::oPrintPS:setAttrLine(aPaper)
          ::setPrintFont(fNORMAL)

          bError := ErrorBlock({|e| ::printError(e)})
BEGIN SEQUENCE
          if ::oPrint:printerStatus() <> XBPPRN_STATUS_READY .and.;
             !PrinterStatus_(::oPrint, ::cUser, ::cMsgId)
             BREAK
          endif
          ::oPrint:startDoc((::cUser + '- computador: ' + ApiGetComputer_()))
          do while .t.
             ::checkEvent()
             if !::readToken(@cToken, @p1, @p2, @p3, @p4)
                exit
             endif
             if     cToken == tROWCOL
                    ::aPos[01] := (::nCol0 + Int((p2 * ::nColWidth)))    // Col := X axe
                    ::aPos[02] := (::nRow0 - Int((p1 * ::nLineHeight)))  // Row := Y axe
             elseif cToken == tSTRING              // Common String
                    nLen          := Len(p1)
                    if nLen        > 0
                       ::aPos[02] += ::nStringYPos
                       GraStringAt(::oPrintPS, ::aPos, p1)
                       ::aPos[02] -= ::nStringYPos
                       ::aPos[01] += (::nColWidth * nLen)
                    endif
             elseif cToken   == tVLINE             // Vertical line.
                    aStartPoint[01] := ((::aPos[01] + ::nVLineX))      // Centering the veritcal line
                    aStartPoint[02] := (::aPos[02]  - ::nLinHorSpace + 2)
                    aEndPoint[01]   := (aStartPoint[01] + (nLINEHEIGHT - 1))
                    aEndPoint[02]   := (::aPos[02] + ((::nLineHeight + ::nLinHorSpace) - nLINEHEIGHT))
                    GraBox(::oPrintPS, aStartPoint, aEndPoint, GRA_FILL)
             elseif cToken   == tHLINE
                    p1              *= ::nColWidth
                    aStartPoint[01] := ::aPos[01]
                    aStartPoint[02] := ((::aPos[02] + ::nLinHorSpace) - 1)
                    aEndPoint[01]   := (aStartPoint[01] + p1 - 1)
                    aEndPoint[02]   := aStartPoint[02]
                    GraLine(::oPrintPS, aStartPoint, aEndPoint)
                    nY              := (nLINEHEIGHT * 2)
                    aStartPoint[02] += nY
                    aEndPoint[02]   += nY
                    GraLine(::oPrintPS, aStartPoint, aEndPoint)
                    ::aPos[01] += p1
             elseif cToken   == tNEWPAGE
                    if ::oPrint:printerStatus() <> XBPPRN_STATUS_READY .and.;
                      !PrinterStatus_(::oPrint, ::cUser, ::cMsgId)
                      BREAK
                    endif
                    ::oPrint:newPage()
                    ::printBG()
             elseif cToken   == tSTARTPAGE
                    if ::oPrint:printerStatus() <> XBPPRN_STATUS_READY .and.;
                      !PrinterStatus_(::oPrint, ::cUser, ::cMsgId)
                      BREAK
                    endif
                    ::oPrint:startPage()
                    ::printBG()
             elseif cToken   == tENDPAGE
                    if ::oPrint:printerStatus() <> XBPPRN_STATUS_READY .and.;
                      !PrinterStatus_(::oPrint, ::cUser, ::cMsgId)
                      BREAK
                    endif
                    ::oPrint:endPage()
             elseif cToken   == tCODEBLOCK
                    Eval(p1, Self)
             elseif cToken   == tPICTURE           // Picture for BG
                    ::loadPicture(p1)
                    ::printBG()
             elseif cToken   == tINITPR
             elseif cToken   == tENDPR
                    exit
             else
                    ::SetPrintFont(cToken)
             endif
          enddo
          ::oPrint:endDoc()
          ::checkEvent()
          lOk := .t.
          ErrorBlock(bError)
RECOVER
          ErrorBlock(bError)
          ::oPrint:abort()
          lOk := .f.
ENDSEQUENCE
          exit
       enddo
RETURN lOk

METHOD PrintForm_:init(cPrtFile,    cFormDest,   cPrinter,       cToFile,;
                       cUser,       cFontFamily, nFontNormWidth, nFontHeight,;
                       nTotColumns, cMsgId,      cCallStack)

       ::Thread:init()
       ::nCharset    := Set(_SET_CHARSET, CHARSET_ANSI)
       ::cPrtFile    := AllTrim(cPrtFile)
       ::cFormDest   := AllTrim(cFormDest)
       ::cPrinter    := AllTrim(cPrinter)
       ::cToFile     := AllTrim(cToFile)
       ::cUser       := (AllTrim(cUser) + ' ')
       ::cFontFamily := AllTrim(cFontFamily)
       ::nColWidth   := nFontNormWidth
       if (::nColWidth % 2) == 0
          ::nVLineX         := Round(((::nColWidth - nLINEHEIGHT) / 2), 0)
       else
          ::nVLineX         := Int(((::nColWidth - nLINEHEIGHT) / 2))
       endif
       ::nVLineX        -= 1
       ::nFontHeight    := nFontHeight
       ::nTotColumns    := nTotColumns
       ::cMsgId         := (cMsgId + ' ')
       ::cCallStack     := cCallStack


       ::nColCondens    := Int((nFontNormWidth / 2))
       ::nColDouble     := (nFontNormWidth     * 2)
       ::oFontNormal    := NIL
       ::oFontNormalEnf := NIL
       ::oFontDobra     := NIL
       ::oFontDobraEnf  := NIL
       ::oFontConden    := NIL
       ::oFontCondenEnf := NIL

       ::lEnfati        := .f.
       ::cBuffer        := Space(nLINESIZE)
       ::nBufferLen     := nLINESIZE
       ::nPos           := 0
       ::cFontStack     := ''
       ::hReport        := 0
       ::nTopPos        := 0
       ::nBottomPos     := 0
       ::nRightPos      := 0
       ::nLeftMargin    := 0
       ::nRow0          := 0
       ::nCol0          := 0
       ::aPos           := {0, 0}
       ::oPrint         := NIL
       ::oPrintPS       := NIL
       ::oPicture       := NIL
       ::aPicTurePos    := {0, 0}
       ::aBG            := Array(PIC_LEN)
       ::atStart        := {|| ::print()}
       ::Thread:start()
//       ::execute()
RETURN Self

METHOD PrintForm_:loadFont(nWidth, lBold, lUndersCore, lItalic)
       LOCAL  oFont

       oFont            := XbpFont():new(::oPrintPS)
       oFont:familyName := ::cFontFamily
       oFont:width      := nWidth
       oFont:height     := ::nFontHeight
       if lItalic       <> NIL;  oFont:italic     := lItalic;      endif
       if lBold         <> NIL;  oFont:bold       := lBold;        endif
       if lUnderscore   <> NIL;  oFont:underscore := lUnderscore;  endif
       oFont:fixed      := .t.
       oFont:vector     := .t.
       oFont:create()
RETURN oFont

METHOD PrintForm_:loadPicture(aPicture)
       LOCAL  cPos

       do while .t.
          if aPicture[I_FILE] == ::aBG[I_FILE] .and.;
             aPicture[I_POS]  == ::aBG[I_POS]
             exit
          endif

          ::oPicture    := LoadBitMap_(::oPrintPS, aPicture[I_FILE])
          if ::oPicture == NIL
             ::aBG      := Array(PIC_LEN)
             exit
          endif

          cPos   := Lower(aPicture[I_POS])
          if     Left(cPos, 1)     == 'l'
                 ::aPicturePos[01] := ::nCol0
          elseif Left(cPos, 1)     == 'r'
                 ::aPicturePos[01] := (::nRightPos - ::oPicture:xSize)
          elseif Left(cPos, 1)     == 'c'
                 ::aPicturePos[01] := (Int((((::nRightPos - ::nCol0) - ::oPicture:xSize) / 2)) +;
                                       ::nCol0)
          endif

          if     Right(cPos, 1)    == 'b'
                 ::aPicturePos[02] := ::nBottomPos
          elseif Right(cPos, 1)    == 't'
                 ::aPicturePos[02] := (::nTopPos - ::oPicture:ySize)
          elseif Right(cPos, 1)    == 'c'
                 ::aPicturePos[02] := (Int((((::nTopPos - ::nBottomPos) - ::oPicture:ySize) / 2)) +;
                                       ::nBottomPos)
          endif
          ::aBG  := AClone(aPicture)
          exit
       enddo
RETURN ::oPicture

METHOD PrintForm_:print()
       LOCAL  cError, nTries

       do while .t.
          nTries          :=  1
          do while nTries <= 30
             ::hReport := FOpen(::cPrtFile)
             if ::hReport > 0
                exit
             endif
             Sleep(30)
             nTries += 1
          enddo
          if ::hReport  < 1
             cError    := ''
             Erro_(NIL, @cError, .f.)

             ::showMsg(NIL, (::cUser                                                    + CR +;
                             'Computador: '                  + ApiGetComputer_()   + CR + CR +;
                             'Relatrio '                    + ::cPrtFile               + CR +;
                             'Destinado para a impressora: ' + AllTrim(::cPrinter)      + CR +;
                             'NO PODE ser acessado. Erro:'                        + CR + CR +;
                             cError),;
                            (::cMsgId + 'ERRO PARA IMPRESSO'),;
                            XBPMB_CANCEL,;
                            (XBPMB_CRITICAL + XBPMB_SYSMODAL))
             exit
          endif

          ::checkEvent()
          if     ::cFormDest == 'hdm' .or.;        // Matricial Printer format ESC P
                 ::cFormDest == 'hdp' .or.;        // Graphic Printer format PCL
                 ::cFormDest == 'exp'              // Exported file
                 ::printToFile()
          elseif ::cFormDest == 'gra'              // Graphic mode
                  ::graphicMode()
          elseif ::cFormDest == 'mat' .or.;        // Format ESC P
                 ::cFormDest == 'pcl'              // Format PCL
                 ::sharedPrinter()
          endif
          exit
       enddo
RETURN NIL

METHOD PrintForm_:printBG()
       if ::oPicture <> NIL
          ::oPicture:draw(::oPrintPS, ::aPicturePos)
       endif
RETURN ::oPicture

METHOD PrintForm_:printError(e)
       if !PrinterError_(e, ::oPrint, ::cUser, ::cMsgId, ::cCallStack)
          BREAK
       endif
RETURN .t.

METHOD PrintForm_:printToFile()
       LOCAL  nHandleO, bError, cError, lOk

       nHandleO := FCreate(::cToFile)
       if nHandleO < 1
          cError    := ''
          Erro_(NIL, @cError, .f.)
          ::showMsg(NIL, (::cUser                             + CR +;
                          'Computador: ' + ApiGetComputer_()  + CR +;
                          'Relatrio destinado para: '        + CR + CR +;
                          ::cToFile                           + CR +;
                          'NO PODE ser criado. Erro:'        + CR +;
                          cError),;
                         (::cMsgId + 'ERRO PARA IMPRESSO'),;
                         XBPMB_CANCEL,;
                         (XBPMB_CRITICAL + XBPMB_SYSMODAL))

       else
          bError := ErrorBlock({|e| ::printError(e)})
BEGIN SEQUENCE
          do while ::readBuffer()
             if ::cFormDest == 'hdm'
                ::conv2Print()
             endif
             if FWrite(nHandleO, ::cBuffer, ::nBufferLen) <> ::nBufferLen
                cError    := ''
                Erro_(NIL, @cError, .f.)
                FClose(nHandleO)
                FErase(nHandleO)
                ::showMsg(NIL, (::cUser                             + CR +;
                                'Computador: ' + ApiGetComputer_()  + CR +;
                                'Relatrio destinado para: '        + CR + CR +;
                                ::cToFile                           + CR +;
                                'NO PODE ser gravado. Erro:'       + CR +;
                                cError),;
                               (::cMsgId + 'ERRO PARA IMPRESSO'),;
                               XBPMB_CANCEL,;
                               (XBPMB_CRITICAL + XBPMB_SYSMODAL))
                BREAK
             endif
          enddo
          FClose(nHandleO)
          lOk := .t.
          ErrorBlock(bError)
RECOVER
          ErrorBlock(bError)
          lOk := .f.
ENDSEQUENCE
       endif
RETURN lOk

METHOD PrintForm_:readBuffer()

       ::nBufferLen := FRead(::hReport, @::cBuffer, nLINESIZE)
       if ::nBufferLen  < nLINESIZE
          ::cBuffer    := Left(::cBuffer, ::nBufferLen)
       endif
       ::nPos := 1
RETURN (::nBufferLen > 0)

METHOD PrintForm_:readBlock(nBlockLen)
       LOCAL  cBlock

       cBlock   := ''
       do while .t.
          ::nPos       += 1
          nBlockLen    -= 1
          if nBlockLen  < 0
             exit
          endif
          if ::nPos > ::nBufferLen
          if !::readBuffer()
             exit
          endif
          endif
          cBlock += ::cBuffer[::nPos]
       enddo
RETURN cBlock

METHOD PrintForm_:readString(cStringRead)
       LOCAL  nAt

       do while ::nPos <= ::nBufferLen    // Final de relatrio
          nAt   := At(Chr(27), ::cBuffer, ::nPos)
          if nAt         == 0
             cStringRead += SubStr(::cBuffer, ::nPos, ((::nBufferLen - ::nPos) + 1))
             ::readBuffer()
             exit
          endif
          cStringRead += SubStr(::cBuffer, ::nPos, (nAt - ::nPos))
          ::nPos      := nAt
          exit
       enddo
RETURN cStringRead

METHOD PrintForm_:readToken(cToken, p1, p2, p3, p4, p5) // Tokens start with Chr(27)
       LOCAL  cString, nCount

       cToken := ''
       do while ::nBufferLen > 0
          if ::nPos > ::nBufferLen .and.;
             !::readBuffer()
             exit
          endif

          cString    := ::cBuffer[::nPos]
          ::nPos     += 1
          if cString <> Chr(27)               // String
             p1      := ::readString(cString)
             ::clearString(@p1)
             if ('' == p1)
                cToken  := ''
                loop
             endif
             cToken := tSTRING
             exit
          endif

          nCount := 0
          do while .t.
             if ::nPos > ::nBufferLen .and.;
                !::readBuffer()
                p1 := ::readString(cString)
                ::clearString(@p1)
                cToken := tSTRING
                exit
             endif

             cString += ::cBuffer[::nPos]
             ::nPos  += 1

             if     Left(cString, 2) == (Chr(27) + '|') // Vertical Line
                    cToken := tVLINE
             elseif Left(cString, 2) == (Chr(27) + '.') // XY coordinates
                    nCount    += 1
                    if nCount  < 5
                       loop
                    endif
                    cToken := tROWCOL
                    p1     := (Bin2W(SubStr(cString, 3, 2)) / 100) // Row
                    p2     := (Bin2W(SubStr(cString, 5, 2)) / 100) // Col
             elseif Left(cString, 2) == (Chr(27) + 'H') // Horizontal Line
                    nCount += 1
                    if nCount < 3
                       loop
                    endif
                    cToken := tHLINE
                    p1     := Bin2W(SubStr(cString, 3, 2))
             elseif cString == (Chr(27) + 'K')         // Cancel current font
                    cToken  := fCANCELA
             elseif cString == (Chr(27) + 'D')         // Select "double size" font
                    cToken  := fDOBRA
             elseif cString == (Chr(27) + 'E')         // Start underlineing
                    cToken  := lENFATI
             elseif cString == (Chr(27) + 'X')         // Stop underlineing
                    cToken  := lCENFATI
             elseif cString == (Chr(27) + 'G')         // :newPage()
                    cToken  := tNEWPAGE
             elseif cString == (Chr(27) + 'N')         // Select "normal" font
                    cToken  := fNORMAL
             elseif cString == (Chr(27) + 'C')         // Select "condensed" font
                    cToken  := fCONDEN
             elseif Left(cString, 2) == (Chr(27) + '!') .or.;   // Code Block
                    Left(cString, 2) == (Chr(27) + '*')         // BG picture
                    nCount += 1
                    if nCount < 2
                       loop
                    endif
                    p1      := ::readBlock(Bin2W(SubStr(cString, 3, 2)))
                    if ''   == p1
                       ::readToken(@cToken, @p1, @p2, @p3, @p4, @p5)
                       exit
                    endif
                    cToken  := iif(Left(cString, 2) == (Chr(27) + '!'),;
                                   tCODEBLOCK,;
                                   tPICTURE)
                    p1      := &(p1)
             elseif cString == (Chr(27) + Chr(255))
                    cToken  := tENDPR
             elseif Left(cString, 2) == (Chr(27) + Chr(27)) // Start of the report file
                    nCount    += 1
                    if nCount  < 6
                       loop
                    endif
                    cToken := tINITPR
                    p1     := Substr(cString,     3, 1)         // Landscape/Portrait
                    p2     := Asc(SubStr(cString, 4, 1))        // Lines per page
                    p3     := Asc(SubStr(cString, 5, 1))        // Left Margin
                    p4     := Asc(SubStr(cString, 6, 1))        // Top  Margin
                    p5     := SubStr(cString, 7, 1)             // Printing level
             elseif cString == (Chr(27) + 'F')         // :endPage()
                    cToken  := tENDPAGE
             elseif cString == (Chr(27) + 'S')         // :startPage()
                    cToken  := tSTARTPAGE
             else                                      // String
                    p1      := ::readString(cString)
                    ::clearString(@p1)
                    cToken := tSTRING
             endif
             exit
          enddo
          exit
       enddo
RETURN ('' <> cToken)

METHOD PrintForm_:selectFont()
       LOCAL  cFont, cFonta, oFont

       cFont  := Right(::cFontStack, 1)
       cFonta := SubStr(::cFontStack, (Len(::cFontStack) - 1), 1)
       if     ::lEnfati
              if     cFont     == fCONDEN
                     if cFonta == fNORMAL
                        oFont  := ::oFontCondenEnf
                     else
                        oFont  := ::oFontNormalEnf
                     endif
              elseif cFont     == fDOBRA
                     if cFonta == fCONDEN
                        oFont  := ::oFontNormalEnf
                     else
                        oFont  := ::oFontDobraEnf
                     endif
              else
                     oFont  := ::oFontNormalEnf
              endif
       elseif cFont     == fCONDEN
              if cFonta == fNORMAL
                 oFont  := ::oFontConden
              else
                 oFont  := ::oFontNormal
              endif
       elseif cFont     == fDOBRA
              if cFonta == fCONDEN
                 oFont  := ::oFontNormal
              else
                 oFont  := ::oFontDobra
              endif
       else
              oFont     := ::oFontNormal
       endif
       ::oprintPS:setFont(oFont)
                  //
                  //    Rendering image parameters that depends on font
       ::nColWidth   := oFont:width
       if (::nColWidth % 2) == 0
          ::nVLineX         := Round(((::nColWidth - nLINEHEIGHT) / 2), 0)
       else
          ::nVLineX         := Int(((::nColWidth - nLINEHEIGHT) / 2))
       endif
       ::nVLineX        -= 1

       ::nStringYPos := Int(((::nLineHeight - oFont:height)      / 2), 0)
       ::nCol0       := (::nLeftMargin * ::nColWidth)
       ::nRightPos   := (::nCol0       + (::nTotColumns * ::nColWidth))
       oFont := NIL
RETURN NIL

METHOD PrintForm_:setPrintFont(cNewFont)
       LOCAL  nLen

       if     cNewFont == fCANCELA        // Cancela Font
              nLen     := Len(::cFontStack)
              if nLen > 1
                 ::cFontStack := Left(::cFontStack, (nLen - 1))
                 ::selectFont()
              endif
       elseif cNewFont == lCENFATI        // Cancela o enfatizado
              if ::lEnfati
                 ::lEnfati := .f.
                 ::selectFont()
              endif
       elseif cNewFont == lENFATI         // Enfatiza
              if !::lEnfati
                 ::lEnfati := .t.
                 ::selectFont()
              endif
       else
              nLen := At(cNewFont, ::cFontStack)
              if     nLen         == 0
                     ::cFontStack += cNewFont
                     ::selectFont()
              elseif cNewFont     <> Right(::cFontStack, 1)
                     ::cFontStack := Left(::cFontStack, nLen)
                     ::selectFont()
              endif
       endif
RETURN Self

METHOD PrintForm_:sharedPrinter()
       LOCAL  bError, cSetDev, nPosToSend, cToSend, lOk

       if ::createPrinter()
          bError  := ErrorBlock({|e| ::printError(e)})
BEGIN SEQUENCE
          cSetDev := Set(_SET_DEVICE, 'Printer')
          Set Printer To Object ::oPrint
          Set Printer On
          do while ::readBuffer()
             if ::oPrint:printerStatus() <> XBPPRN_STATUS_READY .and.;
                !PrinterStatus_(::oPrint, ::cUser, ::cMsgId)
                BREAK
             endif
             if ::cFormDest == 'mat'
                ::conv2Print()
                nPosToSend := 1
                do while .t.
                   cToSend := SubStr(::cBuffer, nPosToSend, nBUFFERMAT)
                   DevOut(cToSend)
                   Sleep(30)
                   nPosToSend      += Min(nBUFFERMAT, Len(cToSend))
                   if ::nBufferLen  < nPosToSend
                      exit
                   endif
                enddo
             else
                DevOut(::cBuffer)
             endif
          enddo
          lOk := .t.
          ErrorBlock(bError)
RECOVER
          ErrorBlock(bError)
          lOk := .f.
ENDSEQUENCE
          Set Printer Off
          Set Printer To
          Set(_SET_DEVICE, cSetDev)
       else
          lOk := .f.
       endif
RETURN lOk

METHOD PrintForm_:showMsg(oOwner, cMens, cTitle, nButtons, nStyle)
       LOCAL  oOldApp, oOldFocus, nAction

       oOldApp   := SetAppWindow ()
       oOldFocus := SetAppFocus()
       nAction   := ConfirmBox(oOwner, cMens, cTitle, nButtons, nStyle)
       SetAppWindow(oOldApp)
       SetAppFocus(oOldFocus)
RETURN nAction
